function hw42

% parameters
n = 201;
V = 50;
k = 1;

numsteps = 50;
tend     = .3;
dt       = tend / (numsteps-1);

% derived quantities
x = linspace(0,10,n).';
h = x(2) - x(1);

Pe = V*h / (2*k);
aopt = coth(abs(Pe)) - 1/Pe;

% get mass and stiffness matrix
[M, K] = heatGlobal(x, V, k, aopt);

% initial conditions
F = zeros(size(x));
t = sin(pi * x) .* (x<1);

% boundary conditions
% u(0) = 0
F = F - K(:,1) * 0;
M(1,:) = [];
M(:,1) = [];
K(1,:) = [];
K(:,1) = [];
F(1,:) = [];
t(1,:) = [];

% u'(10) = 0
% do nothing
% derivative~0 for free for element-wise solution

% results
results = zeros(n, numsteps);

% time loop
[l u] = lu(M + dt*K);

for i = [1:numsteps]
   % add back BC and save
   results(:,i) = [0; t];
   
   % next temp
   t = u \ (l \ (M*t + dt*F));
end

pcolor(x, linspace(0,tend,numsteps), results.');
title('heat distribution');
colormap(jet); shading interp;
xlabel('x'), ylabel('time');